import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.Arguments
import org.junit.jupiter.params.provider.MethodSource
import java.util.stream.Stream

internal class ProductTest {
    @ParameterizedTest(name = "Test that the product has a total price of {0}")
    @MethodSource("provideProducts")
    fun getTotalPrice(totalPrice: Float, product: Product) {
        assertEquals(totalPrice, product.totalPrice)
    }

    companion object {
        @JvmStatic
        fun provideProducts(): Stream<Arguments> {
            return Stream.of(
                Arguments.of(2f, Product(quantity = 1, price = 2f)),
                Arguments.of(3f, Product(quantity = 2, price = 1.5f)),
                Arguments.of(4.5f, Product(quantity = 3, price = 1.5f)),
                Arguments.of(20f, Product(quantity = 10, price = 2f)),
                Arguments.of(0f, Product(quantity = 0, price = 99f)),
            )
        }
    }
}